Index: scripts/usr/local/lib/7dtd/serverconfig.sh
===================================================================
--- scripts/usr/local/lib/7dtd/serverconfig.sh	(revision 119)
+++ scripts/usr/local/lib/7dtd/serverconfig.sh	(revision 204)
@@ -66,4 +66,22 @@
 
 
+serverconfig_ServerDescription_QueryName() {
+	echo "Server description"
+}
+serverconfig_ServerDescription_Type() {
+	echo "string"
+}
+
+
+
+serverconfig_ServerWebsiteURL_QueryName() {
+	echo "Server website URL"
+}
+serverconfig_ServerWebsiteURL_Type() {
+	echo "string"
+}
+
+
+
 serverconfig_ServerPassword_QueryName() {
 	echo "Server password"
@@ -106,5 +124,5 @@
 
 serverconfig_GameName_QueryName() {
-	echo "Game name"
+	echo "Random gen seed"
 }
 serverconfig_GameName_Type() {
@@ -119,5 +137,5 @@
 }
 serverconfig_GameName_ErrorMessage() {
-	echo "Game name cannot be empty."
+	echo "Seed cannot be empty."
 }
 
@@ -125,5 +143,5 @@
 
 serverconfig_GameDifficulty_QueryName() {
-	echo "Difficulty"
+	echo "Difficulty (+ damage given / received)"
 }
 serverconfig_GameDifficulty_Type() {
@@ -134,8 +152,8 @@
 }
 serverconfig_GameDifficulty_Range() {
-	echo "0-4"
+	echo "0-5"
 }
 serverconfig_GameDifficulty_Values() {
-	config_allowed_values=("Very easy" "Easy" "Medium" "Hard" "Very hard")
+	config_allowed_values=("Scavenger (200% / 50%)" "Adventurer (150% / 75%)" "Nomad (100% / 100%)" "Warrior (75% / 150%)" "Survivalist (50% / 200%)" "Insane (25% / 250%)")
 }
 
@@ -175,19 +193,4 @@
 
 
-serverconfig_ShowFriendPlayerOnMap_QueryName() {
-	echo "Show friends on map"
-}
-serverconfig_ShowFriendPlayerOnMap_Type() {
-	echo "boolean"
-}
-serverconfig_ShowFriendPlayerOnMap_Default() {
-	echo "true"
-}
-serverconfig_ShowFriendPlayerOnMap_ErrorMessage() {
-	echo "Not a valid boolean given (true/false or yes/no or y/n)."
-}
-
-
-
 serverconfig_BuildCreate_QueryName() {
 	echo "Item spawn menu"
@@ -197,5 +200,5 @@
 }
 serverconfig_BuildCreate_Default() {
-	echo "true"
+	echo "false"
 }
 serverconfig_BuildCreate_ErrorMessage() {
@@ -212,5 +215,5 @@
 }
 serverconfig_DayNightLength_Default() {
-	echo "45"
+	echo "40"
 }
 
@@ -227,55 +230,4 @@
 }
 serverconfig_FriendlyFire_ErrorMessage() {
-	echo "Not a valid boolean given (true/false or yes/no or y/n)."
-}
-
-
-
-serverconfig_DayCount_QueryName() {
-	echo "Day Count (Horde)"
-}
-serverconfig_DayCount_Type() {
-	echo "number"
-}
-serverconfig_DayCount_Default() {
-	echo "3"
-}
-
-
-
-serverconfig_FragLimit_QueryName() {
-	echo "Frag limit (DM)"
-}
-serverconfig_FragLimit_Type() {
-	echo "number"
-}
-serverconfig_FragLimit_Default() {
-	echo "5"
-}
-
-
-
-serverconfig_MatchLength_QueryName() {
-	echo "Match length (DM)"
-}
-serverconfig_MatchLength_Type() {
-	echo "number"
-}
-serverconfig_MatchLength_Default() {
-	echo "15"
-}
-
-
-
-serverconfig_RebuildMap_QueryName() {
-	echo "Rebuild map on round restart"
-}
-serverconfig_RebuildMap_Type() {
-	echo "boolean"
-}
-serverconfig_RebuildMap_Default() {
-	echo "false"
-}
-serverconfig_RebuildMap_ErrorMessage() {
 	echo "Not a valid boolean given (true/false or yes/no or y/n)."
 }
@@ -408,5 +360,5 @@
 }
 serverconfig_DropOnQuit_Default() {
-	echo "0"
+	echo "1"
 }
 serverconfig_DropOnQuit_Range() {
@@ -456,38 +408,4 @@
 
 
-serverconfig_PlayerDamageGiven_QueryName() {
-	echo "Damage Player->Zombies"
-}
-serverconfig_PlayerDamageGiven_Type() {
-	echo "number"
-}
-serverconfig_PlayerDamageGiven_Default() {
-	echo "2"
-}
-serverconfig_PlayerDamageGiven_Range() {
-	echo "0-4"
-}
-serverconfig_PlayerDamageGiven_Values() {
-	config_allowed_values=("50%" "75%" "100%" "150%" "200%")
-}
-
-
-serverconfig_PlayerDamageRecieved_QueryName() {
-	echo "Damage Zombies->Player"
-}
-serverconfig_PlayerDamageRecieved_Type() {
-	echo "number"
-}
-serverconfig_PlayerDamageRecieved_Default() {
-	echo "2"
-}
-serverconfig_PlayerDamageRecieved_Range() {
-	echo "0-4"
-}
-serverconfig_PlayerDamageRecieved_Values() {
-	config_allowed_values=("50%" "75%" "100%" "150%" "200%")
-}
-
-
 serverconfig_EnemySenseMemory_QueryName() {
 	echo "Sense memory (seconds)"
@@ -670,5 +588,5 @@
 }
 serverconfig_AirDropFrequency_Default() {
-	echo "24"
+	echo "72"
 }
 
@@ -685,14 +603,14 @@
 
 
-serverconfig_VACEnabled_QueryName() {
-	echo "Enable Valve Anti Cheat"
-}
-serverconfig_VACEnabled_Type() {
+serverconfig_EACEnabled_QueryName() {
+	echo "Enable EasyAntiCheat"
+}
+serverconfig_EACEnabled_Type() {
 	echo "boolean"
 }
-serverconfig_VACEnabled_Default() {
+serverconfig_EACEnabled_Default() {
 	echo "true"
 }
-serverconfig_VACEnabled_ErrorMessage() {
+serverconfig_EACEnabled_ErrorMessage() {
 	echo "Not a valid boolean given (true/false or yes/no or y/n)."
 }
@@ -710,6 +628,6 @@
 	echo "--------------------------------"
 	for CV in \
-			ServerName ServerPassword ServerIsPublic ServerPort ServerMaxPlayerCount \
-			DisableNAT VACEnabled MaxSpawnedZombies \
+			ServerName ServerPassword ServerIsPublic ServerPort ServerMaxPlayerCount ServerDescription ServerWebsiteURL \
+			DisableNAT EACEnabled MaxSpawnedZombies \
 			; do
 		$1 $CV
@@ -752,17 +670,4 @@
 }
 
-configEditGameTypeSpecific() {
-	local CV
-	
-	echo "Options for specific game types"
-	echo "--------------------------------"
-	for CV in \
-			DayCount FragLimit MatchLength RebuildMap \
-			; do
-		$1 $CV
-	done
-	echo
-}
-
 configEditGeneric() {
 	local CV
@@ -771,5 +676,5 @@
 	echo "--------------------------------"
 	for CV in \
-			ShowFriendPlayerOnMap FriendlyFire BuildCreate \
+			FriendlyFire BuildCreate \
 			BlockDurabilityModifier \
 			; do
@@ -814,5 +719,5 @@
 	for CV in \
 			GameDifficulty ZombiesRun \
-			PlayerDamageGiven PlayerDamageRecieved EnemySenseMemory EnemySpawnMode EnemyDifficulty \
+			EnemySenseMemory EnemySpawnMode EnemyDifficulty \
 			; do
 		$1 $CV
@@ -839,5 +744,4 @@
 	configEditRemoteControl "$1"
 	configEditGameType "$1"
-	configEditGameTypeSpecific "$1"
 	configEditGeneric "$1"
 	configEditDropLoot "$1"