Index: binary-improvements/AllocsCommands/Commands/ListLandProtection.cs
===================================================================
--- binary-improvements/AllocsCommands/Commands/ListLandProtection.cs	(revision 224)
+++ binary-improvements/AllocsCommands/Commands/ListLandProtection.cs	(revision 230)
@@ -4,41 +4,27 @@
 namespace AllocsFixes.CustomCommands
 {
-	public class ListLandProtection : ConsoleCommand
+	public class ListLandProtection : ConsoleCmdAbstract
 	{
-		public ListLandProtection (ConsoleSdtd cons) : base(cons)
-		{
-		}
-
-		public override string Description ()
+		public override string GetDescription ()
 		{
 			return "lists all land protection blocks and owners";
 		}
 
-		public override string[] Names ()
+		public override string[] GetCommands ()
 		{
 			return new string[] { "listlandprotection", "llp" };
 		}
 
-		public override void ExecuteRemote (string _sender, string[] _params)
+		public override void Execute (List<string> _params, CommandSenderInfo _senderInfo)
 		{
 			try {
-				if (_params.Length >= 1 && _params [0].ToLower ().Equals ("nearby")) {
-					string[] params2 = new string[_params.Length + 1];
-					for (int i = 0; i < _params.Length; i++)
-						params2 [i] = _params [i];
-					params2 [_params.Length] = _sender;
-					_params = params2;
+				if (_senderInfo.RemoteClientInfo != null) {
+					if (_params.Count >= 1 && _params [0].ToLower ().Equals ("nearby")) {
+						_params.Add (_senderInfo.RemoteClientInfo.playerId);
+					}
 				}
-				Run (_params);
-			} catch (Exception e) {
-				Log.Out ("Error in ListLandProtection.ExecuteRemote: " + e);
-			}
-		}
 
-		public override void Run (string[] _params)
-		{
-			try {
-				World w = CommonMappingFunctions.GetGameManager ().World;
-				PersistentPlayerList ppl = CommonMappingFunctions.GetGameManager ().GetPersistentPlayerList ();
+				World w = GameManager.Instance.World;
+				PersistentPlayerList ppl = GameManager.Instance.GetPersistentPlayerList ();
 
 				bool summaryOnly = false;
@@ -48,5 +34,5 @@
 				int closeToDistance = 32;
 
-				if (_params.Length == 1) {
+				if (_params.Count == 1) {
 					long tempLong;
 
@@ -56,30 +42,30 @@
 						steamIdFilter = _params [0];
 					} else {
-						ClientInfo ci = CommonMappingFunctions.GetClientInfoFromNameOrID (_params [0], true);
+						ClientInfo ci = ConsoleHelper.ParseParamIdOrName (_params [0]);
 						if (ci != null) {
-							steamIdFilter = CommonMappingFunctions.GetSteamID (ci);
+							steamIdFilter = ci.playerId;
 						} else {
-							m_Console.SendResult ("Player name or entity id \"" + _params [0] + "\" not found.");
+							SdtdConsole.Instance.Output ("Player name or entity id \"" + _params [0] + "\" not found.");
 							return;
 						}
 					}
-				} else if (_params.Length >= 2) {
+				} else if (_params.Count >= 2) {
 					if (_params [0].ToLower ().Equals ("nearby")) {
 						try {
-							if (_params.Length == 3) {
+							if (_params.Count == 3) {
 								if (!int.TryParse (_params[1], out closeToDistance)) {
-									m_Console.SendResult ("Given radius is not an integer!");
+									SdtdConsole.Instance.Output ("Given radius is not an integer!");
 								}
 							}
-							ClientInfo ci = CommonMappingFunctions.GetClientInfoFromSteamID (_params [_params.Length - 1]);
-							EntityPlayer ep = CommonMappingFunctions.GetEntityPlayer (ci);
+							ClientInfo ci = ConsoleHelper.ParseParamSteamIdOnline (_params [_params.Count - 1]);
+							EntityPlayer ep = w.Players.dict [ci.entityId];
 							closeTo = new Vector3i (ep.GetPosition ());
 							onlyCloseToPlayer = true;
 						} catch (Exception e) {
-							m_Console.SendResult ("Error getting current player's position");
+							SdtdConsole.Instance.Output ("Error getting current player's position");
 							Log.Out ("Error in ListLandProtection.Run: " + e);
 						}
 					} else {
-						m_Console.SendResult ("Illegal parameter list");
+						SdtdConsole.Instance.Output ("Illegal parameter list");
 						return;
 					}
@@ -103,8 +89,8 @@
 							name += " (" + kvp.Key.PlayerId + ")";
 
-							m_Console.SendResult (String.Format ("Player \"{0}\" owns {3} keystones (protected: {1}, current hardness multiplier: {2})", name, w.LandClaimIsActive (kvp.Key), w.LandClaimPower (kvp.Key), kvp.Value.Count));
+							SdtdConsole.Instance.Output (String.Format ("Player \"{0}\" owns {3} keystones (protected: {1}, current hardness multiplier: {2})", name, w.LandClaimIsActive (kvp.Key), w.LandClaimPower (kvp.Key), kvp.Value.Count));
 							if (!summaryOnly) {
 								foreach (Vector3i v in kvp.Value) {
-									m_Console.SendResult ("   (" + v.ToString () + ")");
+									SdtdConsole.Instance.Output ("   (" + v.ToString () + ")");
 								}
 							}
@@ -114,5 +100,5 @@
 
 				if (steamIdFilter.Length == 0)
-					m_Console.SendResult ("Total of " + d.Count + " keystones in the game");
+					SdtdConsole.Instance.Output ("Total of " + d.Count + " keystones in the game");
 			} catch (Exception e) {
 				Log.Out ("Error in ListLandProtection.Run: " + e);