Index: binary-improvements/AllocsCommands/Commands/ShowInventory.cs
===================================================================
--- binary-improvements/AllocsCommands/Commands/ShowInventory.cs	(revision 253)
+++ binary-improvements/AllocsCommands/Commands/ShowInventory.cs	(revision 273)
@@ -5,27 +5,34 @@
 namespace AllocsFixes.CustomCommands
 {
-	public class ShowInventory : ConsoleCmdAbstract {
+	public class ShowInventory : ConsoleCmdAbstract
+	{
 
-		public override string GetDescription () {
+		public override string GetDescription ()
+		{
 			return "list inventory of a given player";
 		}
 
-		public override string GetHelp () {
+		public override string GetHelp ()
+		{
 			return "Usage:\n" +
-				"   showinventory <steam id / player name / entity id>\n" +
-				"Show the inventory of the player given by his SteamID, player name or\n" +
-				"entity id (as given by e.g. \"lpi\")." +
-				"Note: This only shows the player's inventory after it was first sent to\n" +
-				"the server which happens at least every 30 seconds.";
+			"   showinventory <steam id / player name / entity id> [tag]\n" +
+			"Show the inventory of the player given by his SteamID, player name or\n" +
+			"entity id (as given by e.g. \"lpi\").\n" +
+			"Optionally specify a tag that is included in each line of the output. In\n" +
+			"this case output is designed to be easily parseable by tools.\n" +
+			"Note: This only shows the player's inventory after it was first sent to\n" +
+			"the server which happens at least every 30 seconds.";
 		}
 
-		public override string[] GetCommands () {
+		public override string[] GetCommands ()
+		{
 			return new string[] { "showinventory", "si" };
 		}
 
-		public override void Execute (List<string> _params, CommandSenderInfo _senderInfo) {
+		public override void Execute (List<string> _params, CommandSenderInfo _senderInfo)
+		{
 			try {
 				if (_params.Count < 1) {
-					SdtdConsole.Instance.Output ("Usage: showinventory <steamid|playername|entityid>");
+					SdtdConsole.Instance.Output ("Usage: showinventory <steamid|playername|entityid> [tag]");
 					return;
 				}
@@ -37,17 +44,27 @@
 				}
 
+				string tag = null;
+				if (_params.Count > 1 && _params [1].Length > 0) {
+					tag = _params [1];
+				}
+
 				Player p = PersistentContainer.Instance.Players [steamid, false];
 				PersistentData.Inventory inv = p.Inventory;
 
-				SdtdConsole.Instance.Output ("Belt of player " + p.Name + ":");
-				PrintInv (inv.belt);
-				SdtdConsole.Instance.Output (string.Empty);
+				if (tag == null)
+					SdtdConsole.Instance.Output ("Belt of player " + p.Name + ":");
+				PrintInv (inv.belt, p.EntityID, "belt", tag);
+				if (tag == null)
+					SdtdConsole.Instance.Output (string.Empty);
 
-				SdtdConsole.Instance.Output ("Bagpack of player " + p.Name + ":");
-				PrintInv (inv.bag);
-				SdtdConsole.Instance.Output (string.Empty);
+				if (tag == null)
+					SdtdConsole.Instance.Output ("Bagpack of player " + p.Name + ":");
+				PrintInv (inv.bag, p.EntityID, "backpack", tag);
+				if (tag == null)
+					SdtdConsole.Instance.Output (string.Empty);
 
-				SdtdConsole.Instance.Output ("Equipment of player " + p.Name + ":");
-				PrintEquipment (inv.equipment);
+				if (tag == null)
+					SdtdConsole.Instance.Output ("Equipment of player " + p.Name + ":");
+				PrintEquipment (inv.equipment, p.EntityID, "equipment", tag);
 
 			} catch (Exception e) {
@@ -56,34 +73,43 @@
 		}
 
-		private void PrintInv (List<InvItem> _inv) {
+		private void PrintInv (List<InvItem> _inv, int _entityId, string _location, string _tag)
+		{
 			for (int i = 0; i < _inv.Count; i++) {
 				if (_inv [i] != null) {
-					if (_inv [i].quality < 0) {
-						SdtdConsole.Instance.Output (string.Format ("    Slot {0}: {1:000} * {2}", i, _inv [i].count, _inv [i].itemName));
-					} else {
-						SdtdConsole.Instance.Output (string.Format ("    Slot {0}: {1:000} * {2} - quality: {3}", i, _inv [i].count, _inv [i].itemName, _inv [i].quality));
+					if (_tag == null) { // no Tag defined -> readable output
+						if (_inv [i].quality < 0) {
+							SdtdConsole.Instance.Output (string.Format ("    Slot {0}: {1:000} * {2}", i, _inv [i].count, _inv [i].itemName));
+						} else {
+							SdtdConsole.Instance.Output (string.Format ("    Slot {0}: {1:000} * {2} - quality: {3}", i, _inv [i].count, _inv [i].itemName, _inv [i].quality));
+						}
+						DoParts (_inv [i].parts, 1, null);
+					} else { // Tag defined -> parseable output
+						String partsMsg = DoParts(_inv[i].parts, 1, "");
+						String msg = "tracker_item id=" + _entityId + ", tag=" + _tag + ", location=" + _location + ", slot=" + i + ", item=" + _inv[i].itemName + ", qnty=" + _inv[i].count + ", quality=" + _inv[i].quality + ", parts=(" + partsMsg + ")";
+						SdtdConsole.Instance.Output(msg);
 					}
-					DoParts (_inv [i].parts, 1);
 				}
 			}
 		}
 
-		private void PrintEquipment (InvItem[] _equipment) {
-			AddEquipment ("head", _equipment, EquipmentSlots.Headgear);
-			AddEquipment ("eyes", _equipment, EquipmentSlots.Eyewear);
-			AddEquipment ("face", _equipment, EquipmentSlots.Face);
+		private void PrintEquipment (InvItem[] _equipment, int _entityId, string _location, string _tag)
+		{
+			AddEquipment ("head", _equipment, EquipmentSlots.Headgear, _entityId, _location, _tag);
+			AddEquipment ("eyes", _equipment, EquipmentSlots.Eyewear, _entityId, _location, _tag);
+			AddEquipment ("face", _equipment, EquipmentSlots.Face, _entityId, _location, _tag);
 
-			AddEquipment ("armor", _equipment, EquipmentSlots.ChestArmor);
-			AddEquipment ("jacket", _equipment, EquipmentSlots.Jacket);
-			AddEquipment ("shirt", _equipment, EquipmentSlots.Shirt);
+			AddEquipment ("armor", _equipment, EquipmentSlots.ChestArmor, _entityId, _location, _tag);
+			AddEquipment ("jacket", _equipment, EquipmentSlots.Jacket, _entityId, _location, _tag);
+			AddEquipment ("shirt", _equipment, EquipmentSlots.Shirt, _entityId, _location, _tag);
 
-			AddEquipment ("legarmor", _equipment, EquipmentSlots.LegArmor);
-			AddEquipment ("pants", _equipment, EquipmentSlots.Legs);
-			AddEquipment ("boots", _equipment, EquipmentSlots.Feet);
+			AddEquipment ("legarmor", _equipment, EquipmentSlots.LegArmor, _entityId, _location, _tag);
+			AddEquipment ("pants", _equipment, EquipmentSlots.Legs, _entityId, _location, _tag);
+			AddEquipment ("boots", _equipment, EquipmentSlots.Feet, _entityId, _location, _tag);
 
-			AddEquipment ("gloves", _equipment, EquipmentSlots.Hands);
+			AddEquipment ("gloves", _equipment, EquipmentSlots.Hands, _entityId, _location, _tag);
 		}
 
-		private void AddEquipment (string _slotname, InvItem[] _items, EquipmentSlots _slot) {
+		private void AddEquipment (string _slotname, InvItem[] _items, EquipmentSlots _slot, int _entityId, string _location, string _tag)
+		{
 			int[] slotindices = XUiM_PlayerEquipment.GetSlotIndicesByEquipmentSlot (_slot);
 
@@ -91,10 +117,16 @@
 				if (_items != null && _items [slotindices [i]] != null) {
 					InvItem item = _items [slotindices [i]];
-					if (item.quality < 0) {
-						SdtdConsole.Instance.Output (string.Format ("    Slot {0:8}: {1:000}", _slotname, item.itemName));
-					} else {
-						SdtdConsole.Instance.Output (string.Format ("    Slot {0:8}: {1:000} - quality: {2}", _slotname, item.itemName, item.quality));
+					if (_tag == null) { // no Tag defined -> readable output
+						if (item.quality < 0) {
+							SdtdConsole.Instance.Output (string.Format ("    Slot {0:8}: {1:000}", _slotname, item.itemName));
+						} else {
+							SdtdConsole.Instance.Output (string.Format ("    Slot {0:8}: {1:000} - quality: {2}", _slotname, item.itemName, item.quality));
+						}
+						DoParts (_items [slotindices [i]].parts, 1, null);
+					} else { // Tag defined -> parseable output
+						String partsMsg = DoParts(_items[slotindices[i]].parts, 1, "");
+						String msg = "tracker_item id=" + _entityId + ", tag=" + _tag + ", location=" + _location + ", slot=" + _slotname + ", item=" + item.itemName + ", qnty=1, quality=" + item.quality + ", parts=(" +  partsMsg + ")";
+						SdtdConsole.Instance.Output(msg);
 					}
-					DoParts (_items [slotindices [i]].parts, 1);
 					return;
 				}
@@ -102,18 +134,28 @@
 		}
 
-		private void DoParts (InvItem[] _parts, int _indent) {
+		private string DoParts (InvItem[] _parts, int _indent, string _currentMessage)
+		{
 			if (_parts != null && _parts.Length > 0) {
 				string indenter = new string (' ', _indent * 4);
 				for (int i = 0; i < _parts.Length; i++) {
 					if (_parts [i] != null) {
-						if (_parts [i].quality < 0) {
-							SdtdConsole.Instance.Output (string.Format ("{0}         - {1}", indenter, _parts [i].itemName));
-						} else {
-							SdtdConsole.Instance.Output (string.Format ("{0}         - {1} - quality: {2}", indenter, _parts [i].itemName, _parts [i].quality));
+						if (_currentMessage == null) { // no currentMessage given -> readable output
+							if (_parts [i].quality < 0) {
+								SdtdConsole.Instance.Output (string.Format ("{0}         - {1}", indenter, _parts [i].itemName));
+							} else {
+								SdtdConsole.Instance.Output (string.Format ("{0}         - {1} - quality: {2}", indenter, _parts [i].itemName, _parts [i].quality));
+							}
+							DoParts (_parts [i].parts, _indent + 1, _currentMessage);
+						} else { // currentMessage given -> parseable output
+							if (_currentMessage.Length > 0) {
+								_currentMessage += ",";
+							}
+							_currentMessage += _parts[i].itemName + "@" + _parts[i].quality;
+							_currentMessage = DoParts (_parts [i].parts, _indent + 1, _currentMessage);
 						}
-						DoParts (_parts [i].parts, _indent + 1);
 					}
 				}
 			}
+			return _currentMessage;
 		}
 