Index: scripts/usr/local/lib/7dtd/serverconfig.sh
===================================================================
--- scripts/usr/local/lib/7dtd/serverconfig.sh	(revision 262)
+++ scripts/usr/local/lib/7dtd/serverconfig.sh	(revision 294)
@@ -133,5 +133,5 @@
 }
 serverconfig_GameWorld_Values() {
-	config_allowed_values=("Random Gen" "Navezgane" "MP Wasteland Horde" "MP Wasteland Skirmish" "MP Wasteland War")
+	config_allowed_values=("Random Gen" "Navezgane") #  "MP Wasteland Horde" "MP Wasteland Skirmish" "MP Wasteland War"
 }
 
@@ -230,22 +230,74 @@
 }
 serverconfig_DayNightLength_Default() {
-	echo "40"
-}
-
-
-
-serverconfig_FriendlyFire_QueryName() {
-	echo "Friendly fire"
-}
-serverconfig_FriendlyFire_Type() {
+	echo "50"
+}
+
+
+
+serverconfig_DayLightLength_QueryName() {
+	echo "Duration of daylight (in ingame hours)"
+}
+serverconfig_DayLightLength_Type() {
+	echo "number"
+}
+serverconfig_DayLightLength_Default() {
+	echo "18"
+}
+serverconfig_DayLightLength_Range() {
+	echo "0-24"
+}
+
+
+
+serverconfig_PlayerKillingMode_QueryName() {
+	echo "Player killing"
+}
+serverconfig_PlayerKillingMode_Type() {
+	echo "enum"
+}
+serverconfig_PlayerKillingMode_Default() {
+	echo "3"
+}
+serverconfig_PlayerKillingMode_Values() {
+	config_allowed_values=("No player killing" "Kill allies only" "Kill strangers only" "Kill everyone")
+}
+
+
+
+serverconfig_PersistentPlayerProfiles_QueryName() {
+	echo "Persistent player profiles"
+}
+serverconfig_PersistentPlayerProfiles_Type() {
 	echo "boolean"
 }
-serverconfig_FriendlyFire_Default() {
+serverconfig_PersistentPlayerProfiles_Default() {
 	echo "false"
 }
-serverconfig_FriendlyFire_ErrorMessage() {
+serverconfig_PersistentPlayerProfiles_ErrorMessage() {
 	echo "Not a valid boolean given (true/false or yes/no or y/n)."
 }
 
+
+
+serverconfig_PlayerSafeZoneLevel_QueryName() {
+	echo "Safe zone up to player level"
+}
+serverconfig_PlayerSafeZoneLevel_Type() {
+	echo "number"
+}
+serverconfig_PlayerSafeZoneLevel_Default() {
+	echo "5"
+}
+
+
+serverconfig_PlayerSafeZoneHours_QueryName() {
+	echo "Safe zone up to played hours"
+}
+serverconfig_PlayerSafeZoneHours_Type() {
+	echo "number"
+}
+serverconfig_PlayerSafeZoneHours_Default() {
+	echo "5"
+}
 
 
@@ -418,19 +470,4 @@
 
 
-serverconfig_DayLightLength_QueryName() {
-	echo "Day length"
-}
-serverconfig_DayLightLength_Type() {
-	echo "number"
-}
-serverconfig_DayLightLength_Default() {
-	echo "18"
-}
-serverconfig_DayLightLength_Range() {
-	echo "0-24"
-}
-
-
-
 serverconfig_BlockDurabilityModifier_QueryName() {
 	echo "Block durability (%)"
@@ -555,4 +592,19 @@
 
 
+serverconfig_AirDropMarker_QueryName() {
+	echo "Enable AirDrop markers"
+}
+serverconfig_AirDropMarker_Type() {
+	echo "boolean"
+}
+serverconfig_AirDropMarker_Default() {
+	echo "false"
+}
+serverconfig_AirDropMarker_ErrorMessage() {
+	echo "Not a valid boolean given (true/false or yes/no or y/n)."
+}
+
+
+
 serverconfig_MaxSpawnedZombies_QueryName() {
 	echo "Maximum number of concurrent zombies"
@@ -563,4 +615,15 @@
 serverconfig_MaxSpawnedZombies_Default() {
 	echo "60"
+}
+
+
+serverconfig_MaxSpawnedAnimals_QueryName() {
+	echo "Maximum number of concurrent animals"
+}
+serverconfig_MaxSpawnedAnimals_Type() {
+	echo "number"
+}
+serverconfig_MaxSpawnedAnimals_Default() {
+	echo "50"
 }
 
@@ -592,5 +655,5 @@
 	for CV in \
 			ServerName ServerPassword ServerIsPublic ServerPort ServerMaxPlayerCount ServerDescription ServerWebsiteURL \
-			EACEnabled MaxSpawnedZombies \
+			EACEnabled MaxSpawnedZombies MaxSpawnedAnimals \
 			; do
 		$1 $CV
@@ -639,5 +702,7 @@
 	echo "--------------------------------"
 	for CV in \
-			FriendlyFire BuildCreate \
+			PlayerKillingMode PersistentProfiles \
+			PlayerSafeZoneLevel PlayerSafeZoneHours \
+			BuildCreate \
 			BlockDurabilityModifier \
 			; do
@@ -654,5 +719,6 @@
 	for CV in \
 			DropOnDeath DropOnQuit \
-			LootAbundance LootRespawnDays AirDropFrequency \
+			LootAbundance LootRespawnDays \
+			AirDropFrequency AirDropMarker \
 			; do
 		$1 $CV